unit sMessages;
(************************************************************************
sStyle components package 
Copyright (c) 2002 Serge Goncharov. All rights reserved.
                            Ukraine, Odessa
                            http://www.geocities.com/sstylish2002/
                            Serge@HyBce.com
 Version:	1.2, 24-02-2002
*************************************************************************)

interface

uses Messages, Graphics, sStyleUtil;

const

  SM_OFFSET                     = 4444;
  SM_GETSTYLEINFO               = SM_OFFSET;

  SM_SETCAPTIONFONT             = WM_USER + SM_OFFSET + 1;
  SM_SETFONT                    = WM_USER + SM_OFFSET + 2;

  SM_SETFLAT                    = WM_USER + SM_OFFSET + 11;
  SM_SETSHADOWENABLED           = WM_USER + SM_OFFSET + 12;
  SM_SETPARENTCOLOR             = WM_USER + SM_OFFSET + 13;
  SM_SETHOTTRACK                = WM_USER + SM_OFFSET + 14;
  SM_SETEDITABLED               = WM_USER + SM_OFFSET + 15;

  SM_SETCOLORINACTIVE           = WM_USER + SM_OFFSET + 21;
  SM_SETCOLORACTIVE             = WM_USER + SM_OFFSET + 22;
  SM_SETBORDERTOP               = WM_USER + SM_OFFSET + 23;
  SM_SETBORDERBOTTOM            = WM_USER + SM_OFFSET + 24;
  SM_SETCOLORSHADOW             = WM_USER + SM_OFFSET + 25;

  SM_SETKEYNEXT                 = WM_USER + SM_OFFSET + 31;
  SM_SETKEYPREV                 = WM_USER + SM_OFFSET + 32;
  SM_SETPATTERN                 = WM_USER + SM_OFFSET + 33;

  SM_SHADOWTRANSPARENCY         = WM_USER + SM_OFFSET + 41;
  SM_SHADOWOFFSET               = WM_USER + SM_OFFSET + 42;
  SM_SHADOWBLUR                 = WM_USER + SM_OFFSET + 43;

  SM_CHANGESTYLECONTROL         = WM_USER + SM_OFFSET + 52;

  SM_LAST                       = WM_USER + SM_OFFSET + 60;

  // Reserved groupindexes
  GI_START                      = 20;
  GI_FORPANELPATTERN            = 21; // for grouped changing panel patterns

type


  TSMessage = packed record
    Msg: Cardinal;
    GroupIndex: Longint;
    Result: Longint;
  end;

  TSMSetFont = packed record
    Msg: Cardinal;
    GroupIndex: Longint;
    Value: Longint;
    Result: Longint;
  end;

  TSMSetColor = packed record
    Msg: Cardinal;
    GroupIndex: Longint;
    Value: TColor;
    Result: Longint;
  end;

  TSMSetString = packed record
    Msg: Cardinal;
    GroupIndex: Longint;
    Value: string;
    Result: Longint;
  end;

  TSMSetInteger = packed record
    Msg: Cardinal;
    GroupIndex: Longint;
    Value: Longint;
    Result: Longint;
  end;

  TSMSetBoolean = packed record
    Msg: Cardinal;
    GroupIndex: Longint;
    Value: LongBool;
    Result: Longint;
  end;

  TSMGetStyleInfo = packed record
    Msg: Cardinal;
    WParam: Longint;
    LParam: Longint;
    Result: Longint; // sPaintStyle - 1,
                     // sPassiveBGStyle - 2,
                     // ... reserved
                     // sCustomStyle - 4,
                     // sStyle - 5,
                     // sStyleDB - 6
  end;

  TSMChangeStyleControl = packed record
    Msg: Cardinal;
    GroupIndex: Longint;
    sStyleControl: TsStyleControl;
    Result: Longint;
  end;

  TSMSetBground = packed record
    Msg: Cardinal;
    GroupIndex: Longint;
    sBackground: TsBgControl;
    Result: Longint;
  end;

function sMsgToString(i : integer) : string;

implementation

function sMsgToString(i : integer) : string;
begin
  case i of
    SM_OFFSET              : Result := 'SM_OFFSET / SM_GETSTYLEINFO';

    SM_SETCAPTIONFONT      : Result := 'SM_SETCAPTIONFONT';
    SM_SETFONT             : Result := 'SM_SETFONT';

    SM_SETFLAT             : Result := 'SM_SETFLAT';
    SM_SETSHADOWENABLED    : Result := 'SM_SETSHADOWENABLED';
    SM_SETPARENTCOLOR      : Result := 'SM_SETPARENTCOLOR';
    SM_SETHOTTRACK         : Result := 'SM_SETMOUSELIVE';
    SM_SETEDITABLED        : Result := 'SM_SETEDITABLED';

    SM_SETCOLORINACTIVE    : Result := 'SM_SETCOLORINACTIVE';        
    SM_SETCOLORACTIVE      : Result := 'SM_SETCOLORACTIVE';          
    SM_SETBORDERTOP        : Result := 'SM_SETBORDERTOP';            
    SM_SETBORDERBOTTOM     : Result := 'SM_SETBORDERBOTTOM';         
    SM_SETCOLORSHADOW      : Result := 'SM_SETCOLORSHADOW';          

    SM_SETKEYNEXT          : Result := 'SM_SETKEYNEXT';
    SM_SETKEYPREV          : Result := 'SM_SETKEYPREV';
    SM_SETPATTERN          : Result := 'SM_SETPATTERN';              

    SM_SHADOWTRANSPARENCY  : Result := 'SM_SHADOWTRANSPARENCY';      
    SM_SHADOWOFFSET        : Result := 'SM_SHADOWOFFSET';
    SM_SHADOWBLUR          : Result := 'SM_SHADOWBLUR';

    SM_CHANGESTYLECONTROL  : Result := 'SM_CHANGESTYLECONTROL';

    SM_LAST                : Result := 'SM_LAST'
    else                     Result := 'UNKNOWN';
  end;
end;

end.
