unit sRadioButton;
(************************************************************************
sStyle components package 
Copyright (c) 2002 Serge Goncharov. All rights reserved.
                            Ukraine, Odessa
                            http://www.geocities.com/sstylish2002/
                            Serge@HyBce.com
 Version:	1.2, 24-02-2002
*************************************************************************)

interface

uses
  Windows, Messages, Classes, Graphics, Controls, SysUtils, Forms, ExtCtrls, Dialogs,
    sStyleUtil, sCheckedControl, sConst, sGraphUtils;

type
  TsRadioButton = class(TsCheckedControl)
  private
  protected
    function BeforeCheck(Value : boolean): boolean; override;
  public
    constructor Create(AOwner : TComponent); override;
    procedure DrawCheckArea; override;
  published
    property Checked;
    property sStyle;
    property Transparent;
    property Caption;
    property Enabled;
    property Font;
    property Layout;
    property ParentFont;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property Action;
    property Anchors;
    property BiDiMode write SetBidiMode;
    property Constraints;
    property DragKind;
    property ParentBiDiMode;
    property OnEndDock;
    property OnStartDock;
  end;

implementation

uses sPanel;

function TsRadioButton.BeforeCheck(Value : boolean) : boolean;
var
  i : integer;
begin
  Result := False;
  if Value then begin
    if not Checked then begin
      for i := 0 to Parent.ControlCount - 1 do begin
        if (Parent.Controls[i] is TsRadioButton) and (Parent.Controls[i] <> Self)then begin
          TsCheckedControl(Parent.Controls[i]).FChecked := False;
          TsCheckedControl(Parent.Controls[i]).Repaint;
        end;
      end;
      Result := True;
    end;
  end
  else Result := Checked;
end;

constructor TsRadioButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  sStyle.COC := COC_TsDBCheckBox;
end;

procedure TsRadioButton.DrawCheckArea;
var
  R, CheckArea: TRect;
  Color1, Color2 : TColor;
  i : integer;
begin
  case Layout of
    calLeft:  CheckArea := Rect(ClientRect.Left, ClientRect.Top + 1, ClientRect.Left + 13, ClientRect.Top + 14);
    calRight: CheckArea := Rect(ClientRect.Right - 13, ClientRect.Top + 1, ClientRect.Right, ClientRect.Top + 14);
  end;
  R := CheckArea;

  sStyle.FCacheBmp.Canvas.pen.Style := psSolid;
  sStyle.FCacheBmp.Canvas.pen.width := 1;
  sStyle.FCacheBmp.Canvas.brush.color := sStyle.GetActiveColor;

  sStyle.FCacheBmp.Canvas.Ellipse(CheckArea.Left, CheckArea.Top, CheckArea.Right, CheckArea.Bottom);
  if sStyle.Flat then begin
    if sStyle.ControlIsActive and (msBorder in sStyle.Selection.Mode) then begin
      for i := 0 to sStyle.Selection.Border.Width - 1 do begin
        Case sStyle.Selection.Border.Bevel of
          bsFlat : begin
            Color1 := sStyle.Painting.ColorBorderTop;
            Color2 := sStyle.Painting.ColorBorderBottom;
          end;
          bsRaised: begin
            Color1 := LightingColor(sStyle.Painting.ColorBorderTop, 180, i / sStyle.Selection.Border.Width);
            Color2 := LightingColor(sStyle.Painting.ColorBorderBottom, 20, i / sStyle.Selection.Border.Width);
          end;
          bsLowered: begin
            Color1 := DarkingColor(sStyle.Painting.ColorBorderTop, 0, i / sStyle.Selection.Border.Width);
            Color2 := DarkingColor(sStyle.Painting.ColorBorderBottom, 255, i / sStyle.Selection.Border.Width);
          end;
        end;
        DrawEllipseBorder(sStyle.FCacheBmp.Canvas, R.Left + i, R.Top + i, R.Right - i, R.Bottom - i, Color1, Color2);
      end;
    end
    else begin
      DrawEllipseBorder(sStyle.FCacheBmp.Canvas, R.Left, R.Top, R.Right, R.Bottom, sStyle.Painting.ColorBorderTop, sStyle.Painting.ColorBorderBottom);
    end;
  end
  else begin
    DrawEllipseBorder(sStyle.FCacheBmp.Canvas, R.Left, R.Top, R.Right, R.Bottom, clBtnShadow, clWhite);
    DrawEllipseBorder(sStyle.FCacheBmp.Canvas, R.Left + 1, R.Top + 1, R.Right - 1, R.Bottom - 1, clBlack, clBtnShadow);
  end;

  if FChecked then begin
    if Enabled then begin
      sStyle.FCacheBmp.Canvas.pen.color := CheckColor;
      sStyle.FCacheBmp.Canvas.brush.color := CheckColor;
    end
    else begin
      sStyle.FCacheBmp.Canvas.brush.color := clBtnShadow;
      sStyle.FCacheBmp.Canvas.pen.color := clBtnShadow;
    end;
    // Checked
    sStyle.FCacheBmp.Canvas.Ellipse(CheckArea.Left + 3, CheckArea.Top + 3, CheckArea.Right - 3, CheckArea.Bottom - 3);

//    DrawEllipseBorder(Canvas, R.Left + 2 , R.Top + 2, R.Right - 2, R.Bottom - 2, clSilver, clSilver);//Style.GetActiveColor, sStyle.GetActiveColor);
  end
//  else
//  BitBlt(Canvas.Handle, 0, 0, sStyle.FCacheBmp.Width, sStyle.FCacheBmp.Height, sStyle.FCacheBmp.Canvas.Handle, 0, 0, SRCCOPY);
end;

end.

